#include"iomanip"
#include"iostream"
#include"limits"
#include"cmath"
#include"vector"
#include"algorithm"
#include"list"
#include"queue"
#include"stack"
#include"set"
#include"unordered_set"
#include"map"
#include"unordered_map"
#include"string"
#include"cstring"
#include"assert.h"
using namespace std;
#define ff first
#define ss second
#define all(v) v.begin(),v.end()
#define mp make_pair
#define pb push_back
#define mset(a,b) memset(a,b,sizeof(a))
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

const int maxn=1e6+2;
ll sho[maxn][21];
list<pii> adj[maxn];
int n,m,k,s,t;

struct node
{
    ll len;
    int ve,sk;
    node()
    {}
    node(ll a,int b,int c):
        len(a),ve(b),sk(c)
    {}
    bool operator<(const node & ob)const
    {
        return len>ob.len;
    }
};
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m>>k>>s>>t;
    for(int i=0;i<m;++i)
    {
        int x,y,z;
        cin>>x>>y>>z;
        adj[x].pb(mp(y,z));
    }
    if(s==t)
    {
        cout<<"0\n";
        return 0;
    }
    for(int i=1;i<=n;++i)
    {
        for(int j=0;j<21;++j)
            sho[i][j]=1e17;
    }
    for(int i=0;i<=20;++i)
    {
        sho[s][i]=0;
    }
    priority_queue<node>qq;
    qq.push(node(0,s,0));
    while(!qq.empty())
    {
        auto xx=qq.top();
        qq.pop();
        if(xx.len!=sho[xx.ve][xx.sk])
        {
            continue;
        }
        int v=xx.ve;
        for(auto ed:adj[v])
        {
            ll te1=sho[v][xx.sk]+ed.ss;
            if(te1<sho[ed.ff][xx.sk])
            {
                sho[ed.ff][xx.sk]=te1;
                qq.push(node(te1,ed.ff,xx.sk));
            }
            ll te2=sho[v][xx.sk];
            if(xx.sk<20&&te2<sho[ed.ff][xx.sk+1])
            {
                sho[ed.ff][xx.sk+1]=te2;
                qq.push(node(te2,ed.ff,xx.sk+1));
            }
        }
    }
    ll ans=sho[t][0];
    for(int i=1;i<=k;++i)
    {
        if(sho[t][i]<ans)
        {
            ans=sho[t][i];
        }
    }
    cout<<ans<<'\n';
}
