#include"iomanip"
#include"iostream"
#include"limits"
#include"cmath"
#include"vector"
#include"algorithm"
#include"list"
#include"queue"
#include"stack"
#include"set"
#include"unordered_set"
#include"map"
#include"unordered_map"
#include"string"
#include"cstring"
#include"assert.h"
using namespace std;
#define ff first
#define ss second
#define all(v) v.begin(),v.end()
#define mp make_pair
#define pb push_back
#define mset(a,b) memset(a,b,sizeof(a))
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

const int maxn = 1e5+3;

int T[4*maxn];
int a[maxn];

void init(int v, int tl, int tr)
{
    if(tl == tr)
    {
        T[v] = a[tl];
        return;
    }
    int tm = (tl + tr)/2;
    init(2*v, tl, tm);
    init(2*v+1, tm+1, tr);
    T[v] = T[2*v];
    if(T[2*v+1] < T[v])
    {
        T[v] = T[2*v+1];
    }
}
void update(int v, int tl, int tr, int ind)
{
    if(ind<tl||ind>tr)return;
    if(tl == tr && tr == ind)
    {
        T[v] = a[ind];
        return;
    }
    int tm = (tl+tr)/2;
    if(ind<=tm)update(2*v,tl,tm,ind);
    else update(2*v+1,tm+1, tr, ind);
    T[v] = T[2*v];
    if(T[2*v+1] < T[v])
    {
        T[v] = T[2*v+1];
    }
}
int query(int v,int tl, int tr, int l, int r, int x)
{
    //cout<<v<<' '<<tl<<' '<<tr<<' '<<l<<' '<<r<<' '<<x<<" v tl tr l r x\n";
    if(T[v]>x)return -1;
    if(tl == tr && tr == l && l == r)
    {
        if(T[v] <= x)
        {
            return tl;
        }
        else return -1;
    }
    int tm = (tl+tr)/2;
    int ans1 = -1, ans2 = -1;
    if(l>= tm+1)
    {
        return ans2 = query(2*v+1, tm+1, tr, l, r, x);
    }
    if(r<=tm)
    {
        return ans1 = query(2*v, tl, tm, l, r, x);
    }
    if(T[2*v+1]<=x)
        return ans2 = query(2*v+1, tm+1, tr, tm+1, r, x);
    else
        return ans1 = query(2*v, tl, tm, l, tm, x);
}

void pr(int n)
{
    for(int i=0;i<n;++i)
    {
        cout<<a[i]<<' ';
    }
    cout<<'\n';
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,m;
    cin>>n>>m;
    for(int i=0;i<n;++i)cin>>a[i];
    init(1,0,n-1);
    while(m--)
    {
        char ch;
        int i,x;
        cin>>ch;
        if(ch == 'A')
        {
            cin>>i>>x;
            a[i] = x;
            update(1, 0, n-1, i);
        }
        else if(ch == 'I')
        {
            cin>>i>>x;
            cout<<query(1,0,n-1,0,i,x)<<'\n';
        }
        else
        {
            cin>>x;
            cout<<"0\n";
        }
    }
}



